// Illustrates protected inheritance

class Base
{
public:
   void f() {}
   void g() {}
};

class Derived : protected Base
{
public:
   using Base::f;
};

class MoreDerived : public Derived
{
public:
   void h()
   {
      f();  // f and g are protected as far
      g();  // as MoreDerived is concerned
   }
};

int main()
{
   Derived d;
   MoreDerived m;

   m.h();   // okay
   m.f();   // okay
   d.f();   // okay
   m.g();   // error
   d.g();   // error
}

/* Compiler Output:
Error E2247 c:\uvsc\spring02\3370\protected.cpp 34: 'Base::g()' is not accessible in function main()
Error E2247 c:\uvsc\spring02\3370\protected.cpp 35: 'Base::g()' is not accessible in function main()
*/
