// swo.cpp: Ilustrates a strict weak ordering
#include <algorithm>
#include <iostream>
#include <iterator>
#include <set>
#include <string>
using namespace std;

bool not_alpha(char c) {
    return !isalpha(c);
}

// The following function object compares strings by ignoring all non-letters
struct LettersOnly {
public:
    bool operator()(const string& s1, const string& s2) {
        string one, two;

        // Remove non-alpha characters
        remove_copy_if(s1.begin(), s1.end(), back_inserter(one), not_alpha);
        remove_copy_if(s2.begin(), s2.end(), back_inserter(two), not_alpha);

        return one < two;
    }
};

int main() {
    set<string, LettersOnly> stuff;
    stuff.insert("A Man, A Plan, A Canal, Panama");
    stuff.insert("AManAPlanACanalPanama");
    cout << stuff.size() << endl;   // 1
}
