// en.cpp: Ilustrates error propagation
// Call with n >= 20 to see how bad the forward
// formula is.

#include <cmath>
#include <iostream>
using namespace std;

double forward(int n) {
   double en = 1.0 - 1.0/exp(1.0);
   cout << "e0 = " << en << endl;
   for (int i = 1; i <= n; ++i) {
      en = 1 - i*en;
      cout << "e" << i << " = " << en << endl;
   }
   return en;
}

double backward(int n) {
   double en = 1.0 / (n+1);
   cout << "e" << n << " = " << en << endl;
   for (int i = n-1; i >= 0; --i) {
      en = (1 - en)/(i+1);
      cout << "e" << i << " = " << en << endl;
   }
   return en;
}

int main(int argc, char* argv[]) {
   cout << "1/e = " << 1.0/exp(1.0) << endl;
   cout << "1 - 1/e = " << (1.0 - 1.0/exp(1.0)) << endl << endl;
   if (argc == 2) {
      int n = atoi(argv[1]);
      cout << "forward formula:\n";
      forward(n);
      cout << endl;
   
      cout << "backward formula:\n";
      backward(n);
   }
}

