// fa2.cpp: Models a FA over {a b} with a transition table
#include <cstddef>
#include <cstring>
#include <iostream>
using namespace std;

int main(int argc, char* argv[])
{
  enum Letter {A, B, LETTER_COUNT};
  enum State {START, FIRSTA, FIRSTB, SUCCESS, STATE_COUNT};
  State transition[STATE_COUNT][LETTER_COUNT] =
  {
    {FIRSTA, FIRSTB},
    {SUCCESS, FIRSTB},
    {FIRSTA, SUCCESS},
    {SUCCESS, SUCCESS}
  };

  if (argc == 1)
    return 0;
  State state = START;
  size_t numChars = strlen(argv[1]);
  for (size_t i = 0; i < numChars; ++i)
  {
    char c = argv[1][i];
    state = transition[state][c - 'a'];
  }
  cout << boolalpha << (state == SUCCESS) << endl;
}

