// iterate.cpp: Root finding by fixed point iteration
#include <cmath>
#include <cstdlib>
#include <iostream>
#include <limits>
#include "ulps2.h"
using namespace std;

double g(double x) {
   return (x*x + 4) / 5.0;
}

int main(int argc, char* argv[]) {
   if (argc > 1) {
      double guess = atoi(argv[1]);
      double eps = numeric_limits<double>::epsilon();
      cout.precision(numeric_limits<double>::digits10+2);
      for (int i = 0; i < 50; ++i) {
         double next = g(guess);
         cout << i << ": " << next << " (" << ulps(next,guess) << ")\n";
         if (abs(next - guess) <= abs(guess)*eps)
            break;
         guess = next;
      }
   }
}

