// quad1a.cpp (uses single precision)
// Solves the equation x^2 + bx + c = 0 (i.e., a == 1)
// The equation is rigged so that
// b is about the same magnitude as the discriminant, d,
// resulting in loss of precision through subtraction.
#include <cfloat>
#include <cmath>
#include <iostream>
using namespace std;

int main() {
   cout.precision(FLT_DIG-1);
   cout.setf(ios::showpoint);
   cout.setf(ios::scientific);
   float b = -1.0e5f;
   float c = 1.0f;

   float d = b*b -4.0f*c;
   if (d >= 0) {
      // Real roots
      float e = sqrt(d);
      float r1 = (-b - e) / 2.0f;
      float r2 = (-b + e) / 2.0f;
      cout << "r1 = " << r1 << ", r2 = " << r2 << endl;
   }
   else {
      // Complex roots
      float p = -b / 2.0f;
      float q = sqrt(-d) / 2.0f;
      cout << "r1 = " << p << " + " << q << "i\n";
      cout << "r2 = " << p << " - " << q << "i\n";
   }
}

/* Output:
r1 = 0.00000e+00, r2 = 1.00000e+05
*/
