// quad1b.cpp (uses double precision)
// Solves the equation x^2 + bx + c = 0 (i.e., a == 1
// The equation is rigged so that
// b is about the same magnitude as the discriminant, d,
// resulting in loss of precision through subtraction.
#include <cfloat>
#include <cmath>
#include <iostream>
using namespace std;

int main() {
   cout.precision(DBL_DIG-1);
   cout.setf(ios::showpoint);
   cout.setf(ios::scientific);
   double b = -1.0e5;
   double c = 1.0;

   double d = b*b -4.0*c;
   if (d >= 0) {
      // Real roots
      double e = sqrt(d);
      double r1 = (-b - e) / 2.0;
      double r2 = (-b + e) / 2.0;
      cout << "r1 = " << r1 << ", r2 = " << r2 << endl;
   }
   else {
      // Complex roots
      double p = -b / 2.0;
      double q = sqrt(-d) / 2.0;
      cout << "r1 = " << p << " + " << q << "i\n";
      cout << "r2 = " << p << " - " << q << "i\n";
   }
}

/* Output:
r1 = 1.00000033853576e-05, r2 = 9.99999999900000e+04
*/
