#include <algorithm>
#include <cmath>
#include <iostream>
using namespace std;
#include "uni.h"

static const int m1 = 2147483647;
static const int m2 = 65536;
static int i, j, m[18];

void ustart(int iseed) {
   int jseed = min(abs(iseed),m1);

   if (jseed%2 == 0) {
      jseed--;
   }

   int k0 = 9069%m2;
   int k1 = 9069/m2;
   int j0 = jseed%m2;
   int j1 = jseed/m2;

   for (i = 1; i <= 17; i++) {
      jseed = j0*k0;
      j1 = (jseed/m2 + j0*k1 + j1*k0)%(m2/2);
      j0 = jseed%m2;
      m[i] = j0 + m2*j1;
   }         

   i = 5;
   j = 17;
}

double uni() {
   double dk,dm1;
   int k = m[i] - m[j];
   if (k < 0) {
      k += m1;
   }
   m[j] = k;
   i--;
   if (i == 0) {
      i = 17;
   }
   j--;
   if (j == 0) {
      j = 17;
   }

   dk = (double)(k);
   dm1 = (double)(m1);

   return(dk/dm1);
}

